/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.vesey.webservicetest.session;


import java.io.Serializable;
import javax.ejb.Stateful;
import javax.enterprise.context.SessionScoped;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import org.jboss.logging.Logger;

@Named
@Stateful
@SessionScoped
public class LoginBean implements Serializable {

    @Inject
    Logger log;

    @Inject
    FacesContext facesContext;

    private String username;
    private String password;


    public String login() {
        log.info("login: Start");
        log.info("login: Username = " + username);
        log.info("login: Password = " + password);

        HttpServletRequest request = (HttpServletRequest) facesContext.getExternalContext().getRequest();
        try {
            request.login(username, password);
            log.info("login: Login Succeeded. User = " + request.getUserPrincipal().getName());
            return "/secure/test.xhtml";
        } catch (ServletException ex) {
            log.warn("login: Login Failed: " + ex.getLocalizedMessage());
            log.warn("login: Exception: " + ex);
            facesContext.getExternalContext().invalidateSession();
            FacesMessage msg = new FacesMessage(FacesMessage.SEVERITY_WARN, "Login Failed: ", "Username or password incorrect: (" + ex.getLocalizedMessage() + ")");
            facesContext.addMessage(null, msg);
        }
        return null;
    }


    /**
     * @return the username
     */
    public String getUsername() {
        return username;
    }

    /**
     * @param username the username to set
     */
    public void setUsername(String username) {
        this.username = username;
    }

    /**
     * @return the password
     */
    public String getPassword() {
        return password;
    }

    /**
     * @param password the password to set
     */
    public void setPassword(String password) {
        this.password = password;
    }

}
